/*----------------------------------------------------------------
|	Autor: Noel Sanchez Ruiz                                      |
|	Fecha: 29-06-06                    Versin: 1.0	              |
|-----------------------------------------------------------------|
|	Descripcin del Programa:                                     |
|  								                                  |
| ----------------------------------------------------------------*/

// Incluir E/S y Libreras Standard


#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

// Zona de Declaracin de Constantes

const int MAX        = 40;
const int  MAXCAD    = 20;
const char FINCAD    = char(0);
const char ENTER     = '\n';

// Zona de Declaracin de Tipos

typedef char TCadena[MAXCAD+1];
struct Tdatos
{
   TCadena nombre;
   TCadena apellido;
   int telefono;
   int nomina;
};

typedef struct NodoLista *TipoLista;
struct NodoLista
{
   Tdatos valor;
   TipoLista sig;
};

// Zona de Cabeceras de Procedimientos y Funciones

char menu();

char ConfirmaSalida();

Tdatos LeerDatos();

void EscribirDatos(Tdatos emp);

TipoLista Crear();
/* crea una lista enlazada vaca*/

int Lista_Vacia(TipoLista lista);
/* devuelve 1 si la lista enlazada que se le pasa como parmetro 
   est vaca, en caso contrario devuelve 0*/

void Imprimir(TipoLista lista);
/*Imprime el contenido de la lista que se la pasa como parmetro*/

void Insertar_principio(TipoLista &lista, Tdatos elem);
/*Inserta en la cabeza de la lista el registro que se le pasa como 
  parmetro con los datos del empleado*/
  
void Insertar_Final(TipoLista &lista, Tdatos elem);
/*Inserta en el final de la lista el registro que se le pasa como 
  parmetro con los datos del empleado*/
  
void Eliminar_Lista(TipoLista &lista, int telefono);
/* Elimina el elemento de la lista cuyo numero de telefono  
   coincida con el que se pasa como parmetro*/
   
void Insertar_Ordenado(TipoLista &lista, Tdatos elem);
/* A este procedimiento se le pasa una lista ordenada por nomina, 
   e inserta en ella los datos de una nueva persona (almacenados en 
   el registro elem) manteniendo su ordenacin*/
   
void Destruir(TipoLista &lista);
/*Destruye todos los componentes de una lista liberando la memoria*/

void Ordenar_Lista(TipoLista &lista);
/*Para realizar este procedimiento se deber usar como procedimiento 
  auxiliar el subalgoritmo Insertar_Ordenado. 
  Ordenar_Lista recibe una lista enlazada desordenada, y crea una nueva 
  lista ordenada a partir de la anterior (la lista vieja no ordenada se 
  destruye al final del subalgortimo). 
  Para ello Ordenar_Lista va recorriendo la lista antigua, y con cada uno 
  de sus datos va llamando a Insertar_Ordenado*/
  
void copiaCadena(TCadena origen, TCadena & destino);

void Buscar (TipoLista &l, int telefono,int &x);
/* Busca el elemento de la lista cuyo numero de telefono  
   coincida con el que se pasa como parmetro*/

void modificar(TipoLista &l, int telefono);
/* Modifica los elementos de la lista cuyo numero de telefono  
   coincida con el que se pasa como parmetro*/
   
//FICHEROS

Tdatos LeerPersonaTexto(FILE *&fi);

void EscribirPersonaTexto(Tdatos dat, FILE *&fo);


void LeerTexto(TCadena nombre_fichero, TipoLista &l);
/*Abre el fichero para la lectura de datos*/

void EscribirTexto(TipoLista l, TCadena nombre_fichero);
/*Crea un fichero para escribir los datos*/


// Programa Principal

int main()
{
// Zona de Declaracin de Variables del Programa principal  

char op;
  
  int salir,n,x;          /*Las variables globales son usadas para los 'case' del switch*/
  TipoLista lista;
  Tdatos elem;
  TCadena nom_fich;
  salir=1;
  
  lista = Crear();
  
  while(salir == 1)
  {
    op = menu();
    printf("\n");
    
    switch(op)
    {
       case 'A': lista = Crear();
                 printf("La lista ha sido creada...\n");
                 break;
                 
       case 'B': if (Lista_Vacia(lista))
                 printf("La lista esta vacia...\n");
                 else  printf("La lista NO esta vacia,Contiene datos guardados.\nSeleccionar opcion C para Imprimir lista\n\n");     
                 break;
                 
       case 'C': Imprimir(lista);
                 break;
                 
       case 'D': elem = LeerDatos();
                 Insertar_principio(lista, elem);
                 break;
                 
       case 'E': elem = LeerDatos ();
                 Insertar_Final(lista, elem);
                 break;
      
       case 'F': printf("Introduzca el telefono del elemento que quiere eliminar: ");
                 scanf("%d",&n);
                 fflush (stdin);
                 Buscar (lista,n,x);
                 if(x==1)
                 {
                 Eliminar_Lista(lista, n);
                 printf("El elemento ha sido eliminado...\n");
                 }
                 break;
      
       case 'G': elem = LeerDatos();
                 Ordenar_Lista(lista);
                 Insertar_Ordenado(lista, elem);
                 printf("El elemento ha sido insertado correctamente...\n");
                 break;
       
       case 'H': Destruir(lista);
                 printf("La lista ha sido destruida...\n");
                 break;
       
       case 'I': Ordenar_Lista(lista);
                 printf("La lista ha sido ordenada...\n");
                 break;
       
       case 'J': printf("Introduzca nombre de fichero: ");
                 gets(nom_fich);
                 Destruir(lista);
                 LeerTexto(nom_fich, lista);
                 break;
       
       case 'K': printf("Introduzca nombre de fichero: ");
                 gets(nom_fich);
                 EscribirTexto(lista, nom_fich);
                 break;
       
       case 'L': printf("Introduzca el telefono del elemento que quiere buscar: ");
                 scanf("%d",&n);
                 fflush (stdin);
                 Buscar(lista, n,x);
                 break; 
       
       case 'M': printf("Introduzca el telefono del elemento que quiere buscar: ");
                 scanf("%d",&n);
                 fflush (stdin);
                 modificar(lista,n);
                 break; 
       
       case 'X': if(ConfirmaSalida())
                 salir=0;                   
                 else{
                 printf("\n\n");}
                 break;    
    }
    
    system("Pause"); // Hacer una pausa
    system("cls");   // Borrar Pantalla
  
  }
  return 0;	   // Valor de retorno al S.O.
}

// Implementacin de Procedimientos y Funciones

char menu()
{
  char op;
  
  printf ( "\t\tMENU \n ");
  printf(" *****************************\n\n");

  printf("  A.Crear Lista Vacia.\n");
  printf("  B.Comprobar Lista Vacia.\n");
  printf("  C.Imprimir Lista.\n");
  printf("  D.Insertar al Principio de la lista.\n");
  printf("  E.Insertar al Final de la lista.\n");
  printf("  F.Eliminar Elemento de la Lista.\n");
  printf("  G.Insertar Ordenado.\n");
  printf("  H.Destruir Lista Completa.\n");
  printf("  I.Ordenar Lista.(Por Nomina)\n");
  printf("  J.Leer la lista de fichero de texto.(Poner Extension .txt)\n");
  printf("  K.Escribir la lista en fichero de texto.(Poner Extension .txt)\n");
  printf("  L.Buscar por telefono.\n");
  printf("  M.Modificar buscando por telefono.\n");
  printf("  X. Salir del Programa\n\n\n");
  
  printf("  Introduzca su opcion: ");
  
  scanf("%c",&op);
  fflush (stdin); 
  op = toupper(op);
  
  while ( ((op<'A') || (op>'M')) && (op!='X') )
  {
    printf("  Opcion Incorrecta ...\n");
    printf("\n");
    printf("  Introduzca su opcion: ");
    scanf("%c",&op);
    fflush (stdin);
    op = toupper(op);  
  }
  
  return op;

}

char ConfirmaSalida()
{ 
  char car;

  printf("Esta seguro de salir (S/N)? ");
  scanf("%c",&car);
  fflush (stdin);
  car = toupper(car);
  
  return (car=='S');
}


Tdatos LeerDatos()
{
   TCadena s;    
   Tdatos dat;    
       printf("Introduzca: \n");
       printf("\tNombre: ");
       gets (s);    
       fflush (stdin);
       copiaCadena(s, dat.nombre);
       printf("\tApellidos: ");
       gets (s);
       copiaCadena(s, dat.apellido);
       printf("\tTelefono: ");
       scanf("%d",&dat.telefono); 
       fflush (stdin);
       printf("\tNomina: ");
       scanf("%d",&dat.nomina); 
       fflush (stdin);
       
   return dat;
}
void copiaCadena(TCadena origen, TCadena & destino) 
{
     int i;
     i = 0;
     while ((i < MAXCAD) && (origen[i] != FINCAD)) {
           destino[i] = origen[i];
           i++;
     }
     destino[i] = FINCAD;
}

void EscribirDatos(Tdatos emp)
{
     printf("\tNombre:%s\n",emp.nombre);   
     printf("\tApellidos:%s\n",emp.apellido);
     printf("\tTelefono:%d\n",emp.telefono);
     printf("\tNomina:%d\n\n",emp.nomina);
}

TipoLista Crear()
{
   return NULL;
          
}

int Lista_Vacia(TipoLista lista)
{
     if (lista) return 0;          
     return 1;    
          
}
void Imprimir(TipoLista lista)
{
     TipoLista l;
     
     l=lista;
     while (l!=NULL)
     {
        EscribirDatos (l->valor);  
        l=l->sig; 
     }
}

void Insertar_principio(TipoLista &lista, Tdatos elem)
{
     TipoLista n;
		
    n =(NodoLista *)malloc(sizeof (Tdatos));
	if (n==NULL)
      printf("No hay memoria suficiente.");
      else {
    n->valor = elem;
	n->sig = lista;
	lista = n;
           }
}

void Insertar_Final(TipoLista &lista, Tdatos elem)
{
   TipoLista nuevo,ultimo;
   
   nuevo =(NodoLista *)malloc(sizeof (Tdatos));
   if (nuevo==NULL)
      printf("No hay memoria suficiente.");
      else {
   nuevo->valor = elem;
   nuevo->sig = NULL;

   if (lista==NULL)
      {
       lista = nuevo;
      }
   else
   {
       ultimo = lista;
       while (ultimo->sig!=NULL)
       {
             ultimo = ultimo->sig;
       }
       ultimo->sig = nuevo;
   }
            }
}

void Eliminar_Lista(TipoLista &lista, int telefono)
{
  TipoLista ptr,ant;
     
     ptr=lista;
     ant=NULL;
     if(ptr !=NULL)
     {
            while(ptr != NULL)
            {
                      if(ptr->valor.telefono==telefono)
                      {
                         if (ant==NULL)
                         {
                           lista=lista->sig;
                         }
                         else
                         {
                         ant->sig=ptr->sig;
                         }
                         free(ptr);
                         ptr=NULL;
                         
                      }
                      
                      else
                      {
                          ant=ptr;
                          ptr=ptr->sig;
                      }
            
            }
     }
        
     
}

void Insertar_Ordenado(TipoLista &lista, Tdatos elem)
{
   TipoLista nuevo,ptr,ant;
   
   nuevo =(NodoLista *)malloc(sizeof (Tdatos));
   if (nuevo==NULL)
      printf("No hay memoria suficiente.");
      else {
   nuevo->valor = elem;
   
   ptr = lista;
   ant = NULL;
   
   while ( (ptr!=NULL) && (ptr->valor.nomina<elem.nomina) )
   {
      ant = ptr;
      ptr = ptr->sig;
   }

   if (ant==NULL) 
   {
          nuevo->sig = lista;
          lista = nuevo;
   }
   else
   {
          nuevo->sig = ptr;
          ant->sig = nuevo;
   }
            }
}

void Destruir(TipoLista &lista)
{
   TipoLista ptr;
   
   while (lista!=NULL)
   {
      ptr = lista;
      lista = lista->sig;
      free(ptr);
   }
}

void Ordenar_Lista(TipoLista &lista)
{
   TipoLista ptr,aux;
   
   ptr = lista;
   lista = Crear();
   
   while (ptr!=NULL)
   {
      Insertar_Ordenado(lista,ptr->valor);
      aux = ptr;
      ptr = ptr->sig;
      free(aux);
   }
   
}

void Buscar (TipoLista &l, int telefono,int &x)
{
     TipoLista aux;
    
     aux = l;
     while ((aux !=NULL)&& (aux->valor.telefono != telefono))
     {
      aux = aux->sig;     
     }
     if (aux !=NULL)
     {
        x=1;     
        EscribirDatos(aux->valor) ;    
     }
     else
     {
     x=0;
     printf("\nNo se encuentra en la lista\n"); 
     }
}

void modificar(TipoLista &l, int telefono)
{
     int x;
     TipoLista aux;
    
    aux = l;
     
     while ((aux !=NULL)&& (aux->valor.telefono != telefono))
     {
      aux = aux->sig;     
     }
     
     if (aux !=NULL)
     {
     x=1;     
     EscribirDatos(aux->valor) ;    
     }
     
     else
     {
     x=0;
     printf("\nNo se encuentra en la lista\n"); 
     }
     
     if(x==1){ 
      
      printf("Introduzca: \n");
      printf("\tNombre: ");
      gets(aux->valor.nombre);   
      fflush (stdin);
      
      printf("\tApellidos: ");
      gets(aux->valor.apellido);
      fflush (stdin);
      
      printf("\tTelefono: ");
      scanf("%d",&aux->valor.telefono);
      fflush (stdin);
      
      printf("\tNomina: ");
      scanf("%d",&aux->valor.nomina);
      fflush (stdin);
             }
      
}


//FICHEROS

Tdatos LeerPersonaTexto(FILE *&fi) {
 
     Tdatos dat;
     
     fgets(dat.nombre,MAXCAD,fi);
     dat.nombre[strlen(dat.nombre)-1]='\0';
     fflush(stdin);
       
     fgets(dat.apellido,MAXCAD,fi);
     dat.apellido[strlen(dat.apellido)-1]='\0';
     fflush(stdin);
     
     fscanf(fi,"%d\n",&dat.telefono);
     fflush(stdin);
     
     fscanf(fi,"%d\n",&dat.nomina);
     fflush(stdin);
     
     return dat;
 
}

void EscribirPersonaTexto(Tdatos dat, FILE *&fo) 
{
     
     fprintf(fo,"%s\n",dat.nombre);
     fprintf(fo,"%s\n",dat.apellido);
     fprintf(fo,"%d\n",dat.telefono);
     fprintf(fo,"%d\n\n",dat.nomina);
     
}  
void LeerTexto(TCadena nombre_fichero, TipoLista &l) 
{
     
     FILE *fi;
     Tdatos dat;
     
     Destruir(l);
     fi=fopen(nombre_fichero,"rt");
     
     if (fi==NULL) 
     printf("No se pudo abrir el fichero especificado\n");
      
      else {
         
         dat = LeerPersonaTexto(fi);
         
         while(!feof(fi)){ 
               Insertar_Final(l, dat);
               dat = LeerPersonaTexto(fi);
                         }
         
         fclose(fi);
            }
}

void EscribirTexto(TipoLista l, TCadena nombre_fichero) 
{
     int i;
     FILE *fo;
     TipoLista aux;
     fo=fopen(nombre_fichero,"wt");
     
     if (fo==NULL)
     printf("No se pudo crear el fichero especificado\n");              
    
     else{
             aux = l;
             while (aux != NULL) {
                 
                 EscribirPersonaTexto(aux->valor, fo);
                 aux = aux->sig;
                                 }
             fprintf(fo,"\nFIN");   
         }
 fclose(fo);    
}


     
     

